my $PREFIX;
my $DEF_RULES_DIR;
my $LOCAL_RULES_DIR;
my $spamtest;

use Mail::SpamAssassin;
use Mail::SpamAssassin::NoMailAudit;
eval {
	require SDBM_File;
	require Class::Struct;
	require File::Spec::Mac;
	require File::Spec::Unix;
	require File::Spec::Win32;
	require MIME::Decoder::Base64;
	require MIME::Decoder::Binary;
	require MIME::Decoder::Gzip64;
	require MIME::Decoder::NBit;
	require MIME::Decoder::QuotedPrint;
	require MIME::Decoder::UU;	
};

sub initSpamAssassin
{
  my ($rules_dir, $bayes_dir) = @_;

  $spamtest = new Mail::SpamAssassin ({
    rules_filename	=> $rules_dir,
    userstate_dir     => $bayes_dir,
    local_tests_only	=> 1,
    debug             => 0,
    dont_copy_prefs   => 1,
    PREFIX            => "",
    DEF_RULES_DIR     => $rules_dir,
    LOCAL_RULES_DIR   => $rules_dir,
  });

  $spamtest->compile_now(0);
  $spamtest->init_learner();
}

sub spamassassin
{
  my ($spam_file) = @_;

  my $data;
  open($data, $spam_file);
  my @mailtext = <$data>;
  close($data);

  my $mail;
  $mail = Mail::SpamAssassin::NoMailAudit->new ('data' => \@mailtext);

  my $status = $spamtest->check ($mail);
  my $line = $status->getStatusLine();

  return $line; 
};

sub learn
{
	my ($spam_file, $isspam) = @_;	
	
	my $data;
	open($data, $spam_file);
	my @mailtext = <$data>;
	close($data);

	my $mail;
	$mail = Mail::SpamAssassin::NoMailAudit->new ('data' => \@mailtext);
	
	my $learner = $spamtest->learn($mail, undef, $isspam, 0);
	$learner->finish();
}

sub upgrade
{
	$spamtest->upgrade();
}

eval {
	print "init\n";
	initSpamAssassin("C:\\devbin\\Kerio\\MailServer\\spamassassin\\rules\\", "C:\\tmp\\bayes");
	print "learn\n";
	learn("C:\\src\\mailserver\\spamassassin\\spam\\a3541.eml", 1);
	print "OK\n";
#	upgrade();
#	setConfValue("required_hits", "5.0");
#	my $val = getConfValue("required_hits");
#	spamassassin("c:\\dev\\SA_Bad\\messageXP1.eml");
#	spamassassin("c:\\dev\\cvs\\spam\\sample-spam.txt");
#	spamassassin("c:\\dev\\spamassassin\\sample-spam.txt");
#	spamassassin("c:\\dev\\SA-Bad\\message.eml");
#	learn("c:\\dev\\asperl5.6\\site\\usenetspam.eml", 1);
#	spamassassin("c:\\dev\\asperl5.6\\site\\usenetspam.eml");
#    spamassassin("c:\\dev\\asperl5.6\\site\\sample-spam.txt");
#    spamassassin("c:\\dev\\asperl5.6\\site\\sample-nonspam.txt");
#	spamassassin("c:\\dev\\asperl5.6\\site\\falsepositives\\Fw- Norman x Kerio");
#	learn("c:\\dev\\asperl5.6\\site\\falsepositives\\Fw- Norman x Kerio", 1);

#    foreach my $file (get_files_in_test_dir ("c:\\dev\\asperl5.6\\site\\spams\\")) 
#	{
#      spamassassin($file);
#    }
	
	my $tmp = "";
};

sub get_files_in_test_dir {
  my ($dir) = @_;

  opendir(TEST_DIR, $dir) or warn "cannot opendir $dir: $!\n";
  my @cfs = grep { /\.eml$/ && -f "$dir/$_" } readdir(TEST_DIR);
  closedir TEST_DIR;

  return map { "$dir/$_" } sort { $a cmp $b } @cfs;	# sort numerically
}

sub setConfValue {
	my ($valueName, $value) = @_;

	eval { $spamtest->{conf}->{$valueName} = $value; };
}

sub getConfValue {
	my ($valueName) = @_;

	return eval { $spamtest->{conf}->{$valueName}; };	
}